package productv1

import (
	"gitea.timerzz.com/kedaya_haitao/common/pkg/database"
	"gorm.io/gorm/clause"
	"testing"
)

func TestUpsert(t *testing.T) {
	db, err := database.InitDatabase(&database.DBOption{
		Host:     "192.168.31.55",
		User:     "timerzz",
		Password: "zhhg1997",
		Port:     "5432",
		DBName:   "kedaya_dev",
	})
	if err != nil {
		t.Fatal(err)
	}
	err = db.AutoMigrate(&Product{}, &HistoryPrice{})
	if err != nil {
		t.Fatal(err)
	}
	db.Clauses(clause.OnConflict{
		Columns:   []clause.Column{{Name: "pid"}},
		DoUpdates: clause.AssignmentColumns([]string{"name", "color", "link", "orderable", "us_price", "cny_price", "cal_mark", "rate"}),
	}).Create([]Product{
		{
			Name:      "test",
			Pid:       "test-3",
			Color:     "green",
			Link:      "www.baidu.com",
			Image:     "image",
			Orderable: false,
			USPrice:   123,
			DWPrice:   3000,
			Freight:   130,
		},
	})
}

func TestUpdate(t *testing.T) {
	db, err := database.InitDatabase(&database.DBOption{
		Host:     "192.168.31.55",
		User:     "timerzz",
		Password: "zhhg1997",
		Port:     "5432",
		DBName:   "kedaya_dev",
	})
	if err != nil {
		t.Fatal(err)
	}
	var p = Product{Pid: "CJ575-QBO4G", DWPrice: 3000, Freight: 150, Remark: "test", USPrice: 209.3, ExchangeRate: 7.3}
	err = db.Model(&p).Where("pid = ?", p.Pid).Select("dw_price", "freight", "remark", "rate", "cal_mark", "cny_price").Updates(&p).Error
	if err != nil {
		t.Fatal(err)
	}
}
